
/**************************************************************************
 *
 *  Othello II v2.53 - 08/02/2004
 *
 *  Copyright (C) 2000-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Othello II.
 *
 *	Othello II is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Othello II is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Attend un certain temps, donn en millisecondes, talonne pour une HW1
//
//  Cette fonction est tire de Ti-Chess, par Thomas Nussbaumer
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
attend(unsigned short n)
{
  asm("
		boucle:
		move.w	#1020,%%d0
		boucle2:
		dbra	%%d0,boucle2
		dbra	%0,boucle
	"::"d"(n):"d0");
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche les pions sur le plateau et efface les cases vides
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
place_pions()
{
	short   i;
	for (i = 10; i <= 80; i++)
		if (i % 9 != 0)
			draw_pion_case(i, Tableau[i] != VIDE ? Tableau[i] : 13);
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Charge le n-ime coup de la partie stocke dans Sav
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
charger(short coup)
{
	short   i, caze;

	Joueur = BLANC;
	CompteurTotal = 0;
	ProfMax = 0;
	Freq = 0;
	Alfbet[0] = 0;
	GainSur = 0;

	for (i = 10; i <= 80; i++)
		Tableau[i] = VIDE;
	for (i = 0; i < 10; i++)
		Tableau[i] = Tableau[i + 81] = Tableau[9 * i] = DEHORS;
	Tableau[41] = Tableau[49] = NOIR;
	Tableau[40] = Tableau[50] = BLANC;

	for (NbrePions = 4; NbrePions < coup; NbrePions++)	// Rejoue tous les coups depuis le dbut du jeu
	{
		caze = Sav[NbrePions - 4];	// Lit le coup suivant  jouer dans Sav
		if (caze == 0)
			break;

		if (caze < 0)			// Si ce coup est ngatif, c'est aux blancs de jouer
		{						// Enregistrer le joueur permet de ne pas avoir pas de problme quand l'un passe son tour
			Joueur = BLANC;
			caze *= -1;
		}
		else
			Joueur = NOIR;

		prise(caze, Joueur);
	}

	for (i = 10, NbreBlancs = 0; i <= 80; i++)
		if (Tableau[i] == BLANC)
			NbreBlancs++;		// Compte le nombre de pions blancs
}
