
/**************************************************************************
 *
 *  Othello II v2.53 - 08/02/2004
 *
 *  Copyright (C) 2000-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	Othello II is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Othello II is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


#define OPTIMIZE_ROM_CALLS
#define NO_EXIT_SUPPORT

#include "othello2.h"
#include <tigcclib.h>

short   Tableau[91] = { };
char    Sav[61] = { };
short   JoueurType[2] = { 5, 0 };
short   Son = 0, Tips = 1, FaireTourner = 1, Bib = 1;
short   NbrePions = 64, NbreBlancs = 0, NbreOrdi = 0, Joueur = 0, Adversaire = 0, Ordi = 0, GainSur = 0, HW2 = 0;
long    NbreCoups = 0;
char    JmpQuit[56] = { }, JmpReturn[56] = { }, JmpDebut[56] = { };

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void    attend(unsigned short);
void    tourne_pion(void);

#include "interruptions.h"
#include "son.h"
#include "contraste.h"
#include "clavier.h"
#include "graphiques.h"
#include "graphiques_89.h"
#include "biblio.h"
#include "reflexion.h"
#include "divers.h"
#include "menus.h"
#include "sauvegarde.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Procdure appele au lancement, contient la majorit du jeu
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
jeu(void)
{
	short   i;
	short   caze = 40, caz, nbre;
	short  *ptr;
	char    lcd_tampon[2 * LCD_SIZE];

	menu(0);					// Menu de prsentation

	setjmp(JmpDebut);			// Sert  pouvoir recommencer un nouveau jeu

	if (NbreOrdi == 1)
		disp_msg(fr_eng("Bonne", "Good luck!"), fr_eng("chance !", ""), Ordi);

	do							// Boucle principale
	{
	  Boucle:
		Adversaire = Joueur;
		Joueur ^= 1;

		setjmp(JmpReturn);		// Permet de ressortir du menu sans recommencer le jeu

		print_score();			// Affiche le score de chaque joueur

		for (i = 0, nbre = 0; i < 60; i++)	// Affiche un point sur les cases o l'on peut jouer
		{						// et stocke ces cases dans Coup1 pour la rflexion et les coups au hasard
			if (Tableau[caz = Ordre[i]] == VIDE && t_pris(caz, Joueur) != 0)
			{
				Coup1[nbre++] = caz;
				if (JoueurType[Joueur] == HUMAIN && Tips != 0)
					draw_point(caz);
			}
		}
		if (nbre == 0)			// Saute le tour du joueur s'il n'a pas de coup valide et termine le jeu si personne ne peut jouer
		{
			for (i = 0; i < 60; i++)
				if (Tableau[caz = Ordre[i]] == VIDE && t_pris(caz, Adversaire) != 0)
					nbre++;
			if (nbre == 0)
				break;
			if (NbreOrdi < 2)
			{
				lcd_save(lcd_tampon);
				disp_big_msg(NbreOrdi == 1 ? (JoueurType[Joueur] != HUMAIN ?
											  fr_eng("La 89 doit passer !", "The 89 passes!") :
											  fr_eng("Vous devez passer !", "You must pass!")) :
							 (Joueur == BLANC ? fr_eng("Les blancs passent!", " Whites pass!") :
							  fr_eng("Les noirs passent !", " Blacks pass!")));
				lcd_restore(lcd_tampon);
			}
			goto Boucle;
		}
		Coup1[nbre] = 0;
		FontSetSys(PETIT);

		if (JoueurType[Joueur] == HUMAIN)	// Si c'est  un humain de jouer...
		{
			print_etat(Joueur == BLANC ? fr_eng("Aux blancs...", "White's turn...") : fr_eng("Aux noirs...", "Black's turn..."), Joueur);
			do					// Dplacement du curseur jusqu' l'appui sur ENTER sur une case valide
			{
				draw_curseur(caze);
				attend_touche(0);
				draw_curseur(caze);
				caze += HAUT != 0 ? (caze >= 19 ? -9 : 63) :
					(BAS != 0 ? (caze <= 72 ? 9 : -63) :
					 (GAUCHE != 0 ? (caze % 9 >= 2 ? -1 : 7) : (DROITE != 0 ? (caze % 9 <= 7 ? 1 : -7) : 0)));
				if (RETOUR != 0)	// Pour revenir en arrire d'un coup
				{
					if (NbreOrdi == 0)	// Si c'est une partie  deux humains, revenir seulement un coup en arrire...
					{
						print_etat("", Joueur);
						NbrePions--;
					}
					else		// Sinon, revient en arrire jusqu' retrouver un coup du joueur humain
					{
						efface_msg(Adversaire);
						while ((Joueur == BLANC ? -1 : 1) * Sav[--NbrePions - 4] < 0)
							if (NbrePions < 4)
								break;
					}
					charger(NbrePions);
					place_pions();
					goto Boucle;
				}
				if (CATALOG != 0)	// Pour ravancer d'un coup
				{
					if (NbreOrdi == 0)	// Mme chose que pour reculer
					{
						print_etat("", Joueur);
						NbrePions++;
					}
					else
					{
						while ((Joueur == 0 ? -1 : 1) * Sav[++NbrePions - 4] < 0) ;
					}
					charger(NbrePions);
					place_pions();
					goto Boucle;
				}				// Pour passer  la case jouable suivante
				if (PLUS != 0)
					while (Tableau[caze = (++caze - 10) % 71 + 10] != VIDE || t_pris(caze, Joueur) == 0) ;
				if (ESCAPE != 0)
					menu(1);	// Accs au menu
				if (F1 != 0 && NbreOrdi != 0)	// Affiche des statistiques sur la dernire rflexion de l'ordi
				{
					lcd_save(lcd_tampon);
					clr();
					draw_str(0, 16, Niveau[JoueurType[Joueur ^ 1]], 4, 3);
					printf_long2(0, 26, fr_eng("Temps de rflexion : %ld.%ld sec", "Reflection time : %ld.%ld sec"),
								 CompteurTotal / 10, (CompteurTotal % 10) / 2, 3);
					printf_long(0, 36, fr_eng("Profondeur maximale : %ld", "Maximum search depth : %ld"), ProfMax, 3);
					printf_long(0, 46, fr_eng("Vitesse minimale : %ld noeuds/sec", "Minimum speed : %ld nods/sec"),
								(20 * Freq) / (TempsMax + 1), 3);
					printf_long(0, 56, fr_eng("Vitesse maximale : %ld noeuds/sec", "Maximum speed : %ld nods/sec"),
								(20 * Freq) / (TempsMin + 1), 3);
					printf_long(0, 66, fr_eng("Evaluation position : %ld", "Position evaluation : %ld"), Alfbet[0], 3);
					attend_touche(0);
					lcd_restore(lcd_tampon);
					continue;
				}
			}
			while (ENTER == 0 || Tableau[caze] != VIDE || t_pris(caze, Joueur) == 0);
			print_etat("", Joueur);
			if (Tips != 0)
				for (i = 0; i < nbre; i++)
					draw_point(Coup1[i]);
		}
		else					// Si c'est la 89 qui joue...
		{
#ifdef _89
			if ((_rowread(0xffbf) & 1) != 0)	// Si la touche ESC a t appuye,
			{
				if ((Vieilles[6] & 1) == 0)	// et qu'elle n'a pas encore t traite...
				{
					Vieilles[6] += 1;
					menu(1);
				}
			}
			else
				Vieilles[6] = 0;
			if ((_rowread(0xfffd) & 64) != 0)
				off();			// Si la touche CLEAR a t appuye...
#else
			if ((_rowread(0xfeff) & 64) != 0)	// Mme chose pour la 92+
			{
				if ((Vieilles[8] & 64) == 0)
				{
					Vieilles[8] += 64;
					menu(1);
				}
			}
			else
				Vieilles[8] = 0;
			if ((_rowread(0xff7f) & 32) != 0)
				off();
#endif

			NbreCoups = 0;
			efface_msg(Joueur);
			if (JoueurType[Joueur] == STUPIDE || nbre == 1 || NbrePions == 4)
				caze = Coup1[random(nbre)];
			else
			{
				souligne_case(caz = abs(Sav[NbrePions - 5]));
				init_barre(Joueur);
				if ((caze = get_coup_bibli()) == 0)
					caze = analyse(JoueurType[Joueur]);
				souligne_case(caz);
				print_etat("", Joueur);
			}
			print_nbre_examin(Joueur);
			beep(3000, 2);
		}

		draw_pion_case(caze, Joueur);
		Sav[NbrePions - 4] = caze * (Joueur == NOIR ? 1 : -1);
		Sav[NbrePions - 3] = 0;	// Sauvegarde du coup dans Sav

		Prfact = 0;
		nbre = prise(caze, Joueur);
		NbreBlancs += Joueur == BLANC ? nbre + 1 : -nbre;

		if (FaireTourner != 0)
		{
			for (Joueur ? (i = 6) : (i = 2); Joueur ? (i >= 1) : (i <= 7); Joueur ? (i--) : (i++))
			{
				ptr = Memcp[0];
				caz = nbre;
				while (caz--)
					draw_pion_case(*ptr++, i);
				attend(60);
			}
		}
		else
		{
			ptr = Memcp[0];
			while (nbre--)
				draw_pion_case(*ptr++, Joueur);
		}

	}
	while (NbrePions++);		// Passe au tour suivant

	disp_resultat();
	attend_touche(0);

	if (RETOUR != 0 && NbreOrdi < 2)	// Pour revenir en arrire d'un coup, mme quand la partie est finie
	{
		efface_msg(Joueur);
		efface_msg(Adversaire);
		if (NbreOrdi == 0)
		{
			print_etat("", Joueur);
			NbrePions--;
		}
		else
		{
			while ((Ordi == BLANC ? 1 : -1) * Sav[--NbrePions - 4] < 0) ;
		}
		charger(NbrePions);
		place_pions();
		goto Boucle;
	}
	Sav[0] = 0;					// Pour qu'on ne puisse pas charger cette partie qui est finie
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Procdure appele au lancement
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
_main(void)
{
	LCD_BUFFER lcd;

	LCD_save(lcd);
	randomize();
	init_int();
	init_bibli();

	if (init_gray() == FALSE)
	{
		ST_helpMsg(fr_eng("Pas assez de mmoire disponible !", "Not enough memory!"));
		return;
	}

	pokeIO(0x600017, HW2 ? 0x99 : 0x68);	// Force l'interruption 5  s'activer 10 fois par seconde
	charger_sav();
	disp_intro();
	beep(2000, 2);
	beep(900, 2);

	while (setjmp(JmpQuit) == 0)
	{
		transition_debut();
		jeu();
	}

	beep(500, 2);
	beep(900, 2);
	transition_fin();
	GrayOff();
	restaure_int();
	LCD_restore(lcd);
	ST_helpMsg("http://leiber.free.fr/");

	sauver_sav();

	return;
}
